/**
 * 
 */
package com.walletkit.sdk;

import org.json.JSONException;
import org.json.JSONObject;

import com.walletkit.sdk.resources.Pass;
import com.walletkit.sdk.utils.WKJsonWrapper;

/**
 * WalletKit Pass Template.
 * 
 * @author WalletKit <support@walletkit.com>
 * @version 1.0
 */
public class WKPassTemplate extends Pass {

	public String getJson() throws JSONException {
		final JSONObject jsonObj = new JSONObject();
		JSONObject barcodeObj = null;
		if (barcode != null)
			barcodeObj = new JSONObject(barcode);

		jsonObj.put("description", description);
		jsonObj.put("pass_type", passType);
		jsonObj.put("transittype", transitType);
		jsonObj.put("icon", icon);
		jsonObj.put("background", background);
		jsonObj.put("logo", logo);
		jsonObj.put("thumbnail", thumbnail);
		jsonObj.put("strip", strip);
		jsonObj.put("icon2x", icon2x);
		jsonObj.put("background2x", background2x);
		jsonObj.put("logo2x", logo2x);
		jsonObj.put("thumbnail2x", thumbnail2x);
		jsonObj.put("strip2x", strip2x);
		jsonObj.put("logotext", logoText);
		jsonObj.put("username", username);
		jsonObj.put("relevant_date", relevantDate);
		jsonObj.put("foreground_color", foregroundColor);
		jsonObj.put("background_color", backgroundColor);
		jsonObj.put("label_color", labelColor);
		jsonObj.put("barcode", barcodeObj);
		jsonObj.put("location", WKJsonWrapper.getLocationJSON(locations));
		jsonObj.put("headerFields",
					WKJsonWrapper.getHeaderFieldJSON(headerFields));
		jsonObj.put("primaryFields",
					WKJsonWrapper.getPrimaryFieldJSON(primaryFields));
		jsonObj.put("secondaryFields",
					WKJsonWrapper.getSecondaryFieldJSON(secondaryFields));
		jsonObj.put("auxiliaryFields",
					WKJsonWrapper.getAuxiliaryFieldJSON(auxiliaryFields));
		jsonObj.put("backFields", WKJsonWrapper.getBackFieldJSON(backFields));

		return jsonObj.toString();
	}
}
