package com.walletkit.sdk.utils;

import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.walletkit.sdk.resources.AuxiliaryField;
import com.walletkit.sdk.resources.BackField;
import com.walletkit.sdk.resources.HeaderField;
import com.walletkit.sdk.resources.Location;
import com.walletkit.sdk.resources.PrimaryField;
import com.walletkit.sdk.resources.SecondaryField;

public class WKJsonWrapper {

	public static JSONArray getBackFieldJSON(List<BackField> backFields) {
		JSONArray backFieldList = null;
		if (backFields != null && backFields.size() > 0) {
			backFieldList = new JSONArray();
			for (int i = 0; i < backFields.size(); i++) {
				final JSONObject job = new JSONObject();
				final String label = backFields.get(i).getLabel();
				final String key = backFields.get(i).getKey();
				final String value = backFields.get(i).getValue();
				final String textAlignment = backFields.get(i)
						.getTextAlignment();
				final String changeMessage = backFields.get(i)
						.getUpdateMessage();
				try {
					if (WKUtils.isParamSet(label) == true)
						job.put("label", label);
					if (WKUtils.isParamSet(key) == true)
						job.put("key", key);
					if (WKUtils.isParamSet(value) == true)
						job.put("value", value);
					if (WKUtils.isParamSet(textAlignment) == true)
						job.put("textAlignment", textAlignment);
					if (WKUtils.isParamSet(changeMessage) == true)
						job.put("changemessage", changeMessage);
				} catch (JSONException e) {
					e.printStackTrace();
				}

				backFieldList.put(job);
			}
		}
		return backFieldList;
	}

	public static JSONArray
			getAuxiliaryFieldJSON(List<AuxiliaryField> auxiliaryFields) {
		JSONArray auxiliaryFieldList = null;
		if (auxiliaryFields != null && auxiliaryFields.size() > 0) {
			auxiliaryFieldList = new JSONArray();
			for (int i = 0; i < auxiliaryFields.size(); i++) {
				final JSONObject job = new JSONObject();
				final String label = auxiliaryFields.get(i).getLabel();
				final String key = auxiliaryFields.get(i).getKey();
				final String value = auxiliaryFields.get(i).getValue();
				final String textAlignment = auxiliaryFields.get(i)
						.getTextAlignment();
				final String changeMessage = auxiliaryFields.get(i)
						.getUpdateMessage();
				try {
					job.put("label", label);
					job.put("key", key);
					job.put("value", value);
					job.put("textAlignment", textAlignment);
					job.put("changemessage", changeMessage);
				} catch (JSONException e) {
					e.printStackTrace();
				}

				auxiliaryFieldList.put(job);
			}
		}
		return auxiliaryFieldList;
	}

	public static JSONArray
			getSecondaryFieldJSON(List<SecondaryField> secondaryFields) {
		JSONArray secondaryFieldList = null;
		if (secondaryFields != null && secondaryFields.size() > 0) {
			secondaryFieldList = new JSONArray();
			for (int i = 0; i < secondaryFields.size(); i++) {
				final JSONObject job = new JSONObject();
				final String label = secondaryFields.get(i).getLabel();
				final String key = secondaryFields.get(i).getKey();
				final String value = secondaryFields.get(i).getValue();
				final String textAlignment = secondaryFields.get(i)
						.getTextAlignment();
				final String changeMessage = secondaryFields.get(i)
						.getUpdateMessage();
				try {
					if (WKUtils.isParamSet(label) == true)
						job.put("label", label);
					if (WKUtils.isParamSet(key) == true)
						job.put("key", key);
					if (WKUtils.isParamSet(value) == true)
						job.put("value", value);
					if (WKUtils.isParamSet(textAlignment) == true)
						job.put("textAlignment", textAlignment);
					if (WKUtils.isParamSet(changeMessage) == true)
						job.put("changemessage", changeMessage);
				} catch (JSONException e) {
					e.printStackTrace();
				}

				secondaryFieldList.put(job);
			}
		}
		return secondaryFieldList;
	}

	public static JSONArray
			getPrimaryFieldJSON(List<PrimaryField> primaryFields) {
		JSONArray primaryFieldList = null;
		if (primaryFields != null && primaryFields.size() > 0) {
			primaryFieldList = new JSONArray();
			for (int i = 0; i < primaryFields.size(); i++) {
				final JSONObject job = new JSONObject();
				final String label = primaryFields.get(i).getLabel();
				final String key = primaryFields.get(i).getKey();
				final String value = primaryFields.get(i).getValue();
				final String textAlignment = primaryFields.get(i)
						.getTextAlignment();
				final String changeMessage = primaryFields.get(i)
						.getUpdateMessage();
				try {
					if (WKUtils.isParamSet(label) == true)
						job.put("label", label);
					if (WKUtils.isParamSet(key) == true)
						job.put("key", key);
					if (WKUtils.isParamSet(value) == true)
						job.put("value", value);
					if (WKUtils.isParamSet(textAlignment) == true)
						job.put("textAlignment", textAlignment);
					if (WKUtils.isParamSet(changeMessage) == true)
						job.put("changemessage", changeMessage);
				} catch (JSONException e) {
					e.printStackTrace();
				}

				primaryFieldList.put(job);
			}
		}
		return primaryFieldList;
	}

	public static JSONArray getHeaderFieldJSON(List<HeaderField> headerFields) {
		JSONArray headerFieldList = null;
		if (headerFields != null && headerFields.size() > 0) {
			headerFieldList = new JSONArray();
			for (int i = 0; i < headerFields.size(); i++) {
				final JSONObject job = new JSONObject();
				final String label = headerFields.get(i).getLabel();
				final String key = headerFields.get(i).getKey();
				final String value = headerFields.get(i).getValue();
				final String textAlignment = headerFields.get(i)
						.getTextAlignment();
				final String changeMessage = headerFields.get(i)
						.getUpdateMessage();
				try {
					if (WKUtils.isParamSet(label) == true)
						job.put("label", label);
					if (WKUtils.isParamSet(key) == true)
						job.put("key", key);
					if (WKUtils.isParamSet(value) == true)
						job.put("value", value);
					if (WKUtils.isParamSet(textAlignment) == true)
						job.put("textAlignment", textAlignment);
					if (WKUtils.isParamSet(changeMessage) == true)
						job.put("changemessage", changeMessage);
				} catch (JSONException e) {
					e.printStackTrace();
				}

				headerFieldList.put(job);
			}
		}
		return headerFieldList;
	}

	public static JSONArray getLocationJSON(List<Location> locations) {
		JSONArray locationList = null;
		if (locations != null && locations.size() > 0) {
			locationList = new JSONArray();
			for (int i = 0; i < locations.size(); i++) {
				final JSONObject job = new JSONObject();
				final String latitude = locations.get(i).getLatitude();
				final String longitude = locations.get(i).getLongitude();
				final String altitude = locations.get(i).getAltitude();
				final String relevantText = locations.get(i).getRelevantText();
				try {
					if (WKUtils.isParamSet(latitude) == true)
						job.put("latitude", latitude);
					if (WKUtils.isParamSet(longitude) == true)
						job.put("longitude", longitude);
					if (WKUtils.isParamSet(altitude) == true)
						job.put("altitude", altitude);
					if (WKUtils.isParamSet(relevantText) == true)
						job.put("relevanttext", relevantText);
				} catch (JSONException e) {
					e.printStackTrace();
				}

				locationList.put(job);
			}
		}
		return locationList;
	}

}
